/*
 * Copyright Elasticsearch B.V. and/or licensed to Elasticsearch B.V. under one
 * or more contributor license agreements. Licensed under the Elastic License
 * 2.0 and the Server Side Public License, v 1; you may not use this file except
 * in compliance with, at your election, the Elastic License 2.0 or the Server
 * Side Public License, v 1.
 */

import { i18n } from '@kbn/i18n';

export const LOADING_VARIABLES = i18n.translate(
  'alertsUIShared.components.addMessageVariables.loadingMessage',
  {
    defaultMessage: 'Loading variables',
  }
);

export const NO_VARIABLES_FOUND = i18n.translate(
  'alertsUIShared.components.addMessageVariables.noVariablesFound',
  {
    defaultMessage: 'No variables found',
  }
);

export const NO_VARIABLES_AVAILABLE = i18n.translate(
  'alertsUIShared.components.addMessageVariables.noVariablesAvailable',
  {
    defaultMessage: 'No variables available',
  }
);

export const DEPRECATED_VARIABLES_ARE_SHOWN = i18n.translate(
  'alertsUIShared.components.addMessageVariables.deprecatedVariablesAreShown',
  {
    defaultMessage: 'Deprecated variables are shown',
  }
);

export const DEPRECATED_VARIABLES_ARE_HIDDEN = i18n.translate(
  'alertsUIShared.components.addMessageVariables.deprecatedVariablesAreHidden',
  {
    defaultMessage: 'Deprecated variables are hidden',
  }
);

export const HIDE = i18n.translate(
  'alertsUIShared.components.addMessageVariables.hideDeprecatedVariables',
  {
    defaultMessage: 'Hide',
  }
);

export const SHOW_ALL = i18n.translate(
  'alertsUIShared.components.addMessageVariables.showAllDeprecatedVariables',
  {
    defaultMessage: 'Show all',
  }
);

export const ADD_VARIABLE_POPOVER_BUTTON = i18n.translate(
  'alertsUIShared.components.addMessageVariables.addVariablePopoverButton',
  {
    defaultMessage: 'Add variable',
  }
);

export const ADD_VARIABLE_TITLE = i18n.translate(
  'alertsUIShared.components.addMessageVariables.addRuleVariableTitle',
  {
    defaultMessage: 'Add variable',
  }
);
