/*
 * Copyright Elasticsearch B.V. and/or licensed to Elasticsearch B.V. under one
 * or more contributor license agreements. Licensed under the Elastic License
 * 2.0 and the Server Side Public License, v 1; you may not use this file except
 * in compliance with, at your election, the Elastic License 2.0 or the Server
 * Side Public License, v 1.
 */

/*
 * NOTICE: Do not edit this file manually.
 * This file is automatically generated by the OpenAPI Generator, @kbn/openapi-generator.
 *
 * info:
 *   title: Get exception list item API endpoint
 *   version: 2023-10-31
 */

import { z } from 'zod';

import {
  ExceptionListItemId,
  ExceptionListItemHumanId,
  ExceptionNamespaceType,
  ExceptionListItem,
} from '../model/exception_list_common.gen';

export type GetExceptionListItemRequestQuery = z.infer<typeof GetExceptionListItemRequestQuery>;
export const GetExceptionListItemRequestQuery = z.object({
  /**
   * Either `id` or `item_id` must be specified
   */
  id: ExceptionListItemId.optional(),
  /**
   * Either `id` or `item_id` must be specified
   */
  item_id: ExceptionListItemHumanId.optional(),
  namespace_type: ExceptionNamespaceType.optional().default('single'),
});
export type GetExceptionListItemRequestQueryInput = z.input<
  typeof GetExceptionListItemRequestQuery
>;

export type GetExceptionListItemResponse = z.infer<typeof GetExceptionListItemResponse>;
export const GetExceptionListItemResponse = ExceptionListItem;
