/*
 * Copyright Elasticsearch B.V. and/or licensed to Elasticsearch B.V. under one
 * or more contributor license agreements. Licensed under the Elastic License
 * 2.0 and the Server Side Public License, v 1; you may not use this file except
 * in compliance with, at your election, the Elastic License 2.0 or the Server
 * Side Public License, v 1.
 */

/*
 * NOTICE: Do not edit this file manually.
 * This file is automatically generated by the OpenAPI Generator, @kbn/openapi-generator.
 *
 * info:
 *   title: Patch list API endpoint
 *   version: 2023-10-31
 */

import { z } from 'zod';

import { ListId, ListName, ListDescription, ListMetadata } from '../model/list_common.gen';
import { List } from '../model/list_schemas.gen';

export type PatchListRequestBody = z.infer<typeof PatchListRequestBody>;
export const PatchListRequestBody = z.object({
  id: ListId,
  name: ListName.optional(),
  description: ListDescription.optional(),
  meta: ListMetadata.optional(),
  version: z.number().int().min(1).optional(),
  _version: z.string().optional(),
});
export type PatchListRequestBodyInput = z.input<typeof PatchListRequestBody>;

export type PatchListResponse = z.infer<typeof PatchListResponse>;
export const PatchListResponse = List;
