/*
 * Copyright Elasticsearch B.V. and/or licensed to Elasticsearch B.V. under one
 * or more contributor license agreements. Licensed under the Elastic License
 * 2.0 and the Server Side Public License, v 1; you may not use this file except
 * in compliance with, at your election, the Elastic License 2.0 or the Server
 * Side Public License, v 1.
 */

/*
 * NOTICE: Do not edit this file manually.
 * This file is automatically generated by the OpenAPI Generator, @kbn/openapi-generator.
 *
 * info:
 *   title: Get list item API endpoint
 *   version: 2023-10-31
 */

import { z } from 'zod';

import { ListId } from '../model/list_common.gen';
import { ListItem } from '../model/list_schemas.gen';

export type GetListItemRequestQuery = z.infer<typeof GetListItemRequestQuery>;
export const GetListItemRequestQuery = z.object({
  /**
   * Required if `list_id` and `value` are not specified
   */
  id: ListId.optional(),
  /**
   * Required if `id` is not specified
   */
  list_id: ListId.optional(),
  /**
   * Required if `id` is not specified
   */
  value: z.string().optional(),
});
export type GetListItemRequestQueryInput = z.input<typeof GetListItemRequestQuery>;

export type GetListItemResponse = z.infer<typeof GetListItemResponse>;
export const GetListItemResponse = z.union([ListItem, z.array(ListItem)]);
